local function search(wo,container,title,isWorld)
    if CIFUI.instance then
        CIFUI.instance:close()
    end 
    if not isWorld then
        CIFUI:show(container,title)
    else
        local player = getPlayer()
        clickedSquare = luautils.getCorrectSquareForWall(player, clickedSquare);
        local adjacent = AdjacentFreeTileFinder.Find(clickedSquare, player);
        if adjacent then
            local action = ISWalkToTimedAction:new(player, adjacent)
            action:setOnComplete(function()
                CIFUI:show(container,title) 
            end)
            ISTimedActionQueue.add(action)
        end
    end
end

local function OnFillInventoryObjectContextMenu(player, context, items)
    items = ISInventoryPane.getActualItems(items)
    if not items then return end
    local item = items[1]
    if not item then return end
    local container = item:getContainer()
    if not container then return end
    if container:isInCharacterInventory(getPlayer()) then return end
    local loot = getPlayerLoot(player)
    container = loot.inventory
    if not container then return end
    local title = loot.title
    context:addOption(getText("IGUI_CIF_SearchIn") .. title,wo,search,container,title,false);
end

local function OnFillWorldObjectContextMenu(player, context, worldObjects, test)
    local wo = worldObjects[1]
    if wo then
        if instanceof(wo, "IsoThumpable") and ( wo:isLocked() or wo:isLockedByKey() or wo:isLockedByPadlock() or wo:isLockedToCharacter(getPlayer())) then
            return
        end
        local container = worldObjects[1]:getContainer()
        if container then 
            local title = getText("IGUI_ContainerTitle_"..container:getType())
            context:addOption(getText("IGUI_CIF_SearchIn").. title,wo,search,container,title,true);
        end
    end 
end

Events.OnFillWorldObjectContextMenu.Add(OnFillWorldObjectContextMenu)
Events.OnFillInventoryObjectContextMenu.Add(OnFillInventoryObjectContextMenu);